// integralMain.c
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
//#include "..\expr\compat.h"
#include "..\rtime\DCgenS.h"
//#include "..\expr\eval.h"
//#include "testUtils.h"
//#include "test.h"

FILE *outFile;
FILE *outEFile;
typedef double FUNC(double);
typedef FUNC* PFUNC;
int step = 4;
int mainf(int argc,char **argv);
int maind();

void skipBlanks(FILE *inp)
{
	char ch;

	ch = 0;
	
	ch = fgetc(inp);
	while ((ch == '\n') || (ch == ' ') || (ch == '\t')) {
		ch = fgetc(inp);
		if (ch == EOF)
			return;
	}
	ungetc(ch,inp);
	return;
}
char *GetExp(FILE *inp,char *expStr)
{
	int ch;
	int parcnt;
	char *chpt;

	ch = fgetc(inp);

	if (ch != '(')
		return NULL;
	chpt = expStr;
	*chpt = ch;
	chpt++;
	parcnt = 1;
	while (parcnt > 0) {
		ch = fgetc(inp);
		if (ch == '(')
			parcnt++;
		else if (ch == ')')
			parcnt--;
		*chpt = ch;
		chpt++;
		if (ch == -1)
			return NULL;
	}
	return expStr;
}

double integrate(expression *f,expression *var, double startx, double endx)
{
	int istep;
	double h;
	double delta;
	double res;

	expression *y0,*yn,*ynext;
	if ((step %2) != 0)
		istep = step+1;
	else istep = step;
	delta = (endx-startx)/istep;

	yn = newExpression("=",var,newExpression(endx));
	y0 = newExpression("=",var,newExpression(startx));
	ynext = newExpression("=",var,newExpression("+",var,newExpression((double) delta)));
	yn->eval();
	res = f->eval().evalDouble();
	y0->eval();
	res += f->eval().evalDouble();
	ynext->eval();
	res += 4*f->eval().evalDouble();
	h = 2*(endx-startx)/istep;

	for (int i = 1; (i<istep-2); i += 2) {
		ynext->eval();
		res += 2*f->eval().evalDouble();
		ynext->eval();
		res += 4*f->eval().evalDouble();
	}

	res = res * h/6;

	return res;
}

int maind()
{
	expression *f1;
	expression *var;
	double startx,endx;
	double intres;

	//var = newExpression("x",newExpression((double) 0));
	var = newExpression("x",(double) 0.);

	f1 = newExpression((double) 4.);
	startx = 0.;
	endx = 10.;
	intres = integrate(f1,var,startx,endx);
	printf ("integrate ");
	f1->print();
	printf(" From %e to %e:\nresult= ** %e **\n",startx,endx,intres);
	printf("****************************************************\n");
	f1 = var;
	intres = integrate(f1,var,startx,endx);
	printf ("integrate ");
	f1->print();
	printf(" From %e to %e:\nresult= ** %e **\n",startx,endx,intres);
	printf("****************************************************\n");
	f1 = newExpression("call","sqrt",
		newExpression("-",newExpression((double) 100.),
		newExpression("call","pow",var,newExpression((int) 2))));
	step = 100;
	intres = integrate(f1,var,startx,endx);
	printf ("integrate ");
	f1->print();
	printf(" From %e to %e:\nresult= ** %e **\n",startx,endx,intres);
	printf("****************************************************\n");
	f1 = newExpression("call","log",var);
	step = 100;
	startx = 1.;
	endx = 10.;
	intres = integrate(f1,var,startx,endx);
	printf ("integrate ");
	f1->print();
	printf(" From %e to %e:\nresult= ** %e **\n",startx,endx,intres);
	printf("****************************************************\n");
	getchar();
	return 0;
}

int main(int argc,char **argv)
{
	if (argc > 1)  
		return mainf(argc,argv);
	printf("No input file - using default data\n");
	return maind();
}
int mainf(int argc,char **argv)
{
	expression *var;
	expression *intg;
	char varName[256];
	char exprStr[256];
	char *exprStrp;
	double intres;
	double startx,endx;
	FILE *inpFile;
	errno_t err;

	err = Fopen(inpFile,argv[1],"r");
	if ((inpFile == NULL) || (err != 0)) {
		printf("failed to open file %s\n",argv[1]);
		exit(1);
	}
	var = newExpression("x",(double) 0.);
	fseek( inpFile, 0L, SEEK_SET );
	exprStrp = GetExp(inpFile,exprStr);
	while (exprStrp != NULL) {
		Fscanf(inpFile,"%s",varName,5);
		Fscanf(inpFile,"%Lf",&startx);
		Fscanf(inpFile,"%Lf",&endx);
		var = getExpression(varName); 
		if (var == NULL) {
			printf ("Could not find variable %s: Using generic name x\n",varName);
			var = newExpression("x",0);
		}
		intg = parse(exprStrp);
		intres = integrate(intg,var,startx,endx);
		printf("Integrating expression \n(");
		intg->print();
		printf(")d%s",var->getName());
		printf(" in range (%f - %f)\n",startx,endx);
		printf("integral result=%f\n",intres);
		skipBlanks(inpFile);
		exprStrp = GetExp(inpFile,exprStr);
		printf("*****************************************\n");
	}
	getchar();
	return 0;
}